"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _rnFetchBlob = _interopRequireDefault(require("rn-fetch-blob"));

var _createBlobRecord = _interopRequireDefault(require("./createBlobRecord"));

var id = 0;

var _default = function _default(_ref, onStatusChange) {
  var directUploadsUrl = _ref.directUploadsUrl,
      file = _ref.file;
  var taskId = ++id;
  var canceled = false;
  var task;

  var handleCancel = function handleCancel() {
    if (!task) {
      return;
    }

    canceled = true;
    task.cancel();
  };

  var handleStatusUpdate = function handleStatusUpdate(data) {
    onStatusChange((0, _objectSpread2["default"])({}, data, {
      id: taskId,
      cancel: handleCancel,
      file: file
    }));
  };

  handleStatusUpdate({
    status: 'waiting'
  });
  return new Promise(
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(resolve, reject) {
      var blobData, _blobData$direct_uplo, url, headers, fileData;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _createBlobRecord["default"])({
                directUploadsUrl: directUploadsUrl,
                file: file
              });

            case 2:
              blobData = _context.sent;
              _blobData$direct_uplo = blobData.direct_upload, url = _blobData$direct_uplo.url, headers = _blobData$direct_uplo.headers;
              fileData = _rnFetchBlob["default"].wrap(file.path);
              task = _rnFetchBlob["default"].fetch('PUT', url, headers, fileData);
              task.uploadProgress({
                interval: 250
              }, function (loaded, total) {
                var progress = loaded / total * 100;
                handleStatusUpdate({
                  status: 'progress',
                  progress: progress
                });
              }).then(function (resp) {
                var status = resp.info().status;

                if (status >= 200 && status < 400) {
                  handleStatusUpdate({
                    status: 'finished'
                  });
                } else {
                  handleStatusUpdate({
                    status: 'error'
                  });
                }

                resolve(blobData.signed_id);
              })["catch"](function (err) {
                if (canceled) {
                  handleStatusUpdate({
                    status: 'canceled'
                  });
                } else {
                  handleStatusUpdate({
                    status: 'error'
                  });
                }

                resolve();
              });

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }());
};

exports["default"] = _default;