import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import RNFetchBlob from 'rn-fetch-blob';
import createBlobRecord from './createBlobRecord';
var id = 0;
export default (function (_ref, onStatusChange) {
  var directUploadsUrl = _ref.directUploadsUrl,
      file = _ref.file;
  var taskId = ++id;
  var canceled = false;
  var task;

  var handleCancel = function handleCancel() {
    if (!task) {
      return;
    }

    canceled = true;
    task.cancel();
  };

  var handleStatusUpdate = function handleStatusUpdate(data) {
    onStatusChange(_objectSpread({}, data, {
      id: taskId,
      cancel: handleCancel,
      file: file
    }));
  };

  handleStatusUpdate({
    status: 'waiting'
  });
  return new Promise(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee(resolve, reject) {
      var blobData, _blobData$direct_uplo, url, headers, fileData;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return createBlobRecord({
                directUploadsUrl: directUploadsUrl,
                file: file
              });

            case 2:
              blobData = _context.sent;
              _blobData$direct_uplo = blobData.direct_upload, url = _blobData$direct_uplo.url, headers = _blobData$direct_uplo.headers;
              fileData = RNFetchBlob.wrap(file.path);
              task = RNFetchBlob.fetch('PUT', url, headers, fileData);
              task.uploadProgress({
                interval: 250
              }, function (loaded, total) {
                var progress = loaded / total * 100;
                handleStatusUpdate({
                  status: 'progress',
                  progress: progress
                });
              }).then(function (resp) {
                var status = resp.info().status;

                if (status >= 200 && status < 400) {
                  handleStatusUpdate({
                    status: 'finished'
                  });
                } else {
                  handleStatusUpdate({
                    status: 'error'
                  });
                }

                resolve(blobData.signed_id);
              })["catch"](function (err) {
                if (canceled) {
                  handleStatusUpdate({
                    status: 'canceled'
                  });
                } else {
                  handleStatusUpdate({
                    status: 'error'
                  });
                }

                resolve();
              });

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }());
});